/* This is the main window for our precision test.
 * It inherits from the QMainDialog class.
 * 
 * author: Lukas Novosad - novosluk@fel.cvut.cz
 * date: 28/9/2010
 *
 */

#include "exercise_1.h"

exercise_1::exercise_1(QWidget *parent, Qt::WFlags flags)
	: QMainWindow(parent, flags)
{
	ui.setupUi(this);

	centralWidget.setParent(this);

	// sets the central widget for the Qt main window
	// in our case this is the widget which draws the precision test
	setCentralWidget(&centralWidget);

	// Qt connect statements
	QObject::connect(this, SIGNAL(epsilonExponentChanged(int)), &centralWidget, SLOT(setEpsilonExponent(int)));
	QObject::connect(this, SIGNAL(precisionChanged(Precision)), &centralWidget, SLOT(setPrecision(Precision)));

}

exercise_1::~exercise_1()
{

}

void exercise_1::createAboutDialog()
{
	aboutDialog.setModal(true);
	aboutDialog.show();
}

void exercise_1::createEpsilonDialog()
{
	bool ok;
	int value;

	value = QInputDialog::getInteger(this,
									 tr("Epsilon value"),
									 tr("Set the exponent to be used for the epsilon value.\n"
									 "The base is 2."),
									 centralWidget.getEpsilonExponent(), -126, +127, 1, &ok);

	if(ok)
		emit epsilonExponentChanged(value);
	
}

void exercise_1::setPrecisionCF()
{
	emit precisionChanged(CF);
}

void exercise_1::setPrecisionCD()
{
	emit precisionChanged(CD);
}

//TODO: implement the additional slot defined via the Qt Designer